#include <cstdio>
#include <algorithm>

int autori[100001];
int prvi, drugi,s[100001],l,k,n,resenje[100001];
int isti(int s[100001],int l){
   int t=s[0];
   int max=0;
  for(int i=1;i<l;i++){
     if(s[i]==t)
       max++;
     else
       t=s[i];
  }
  return max;
}

int main(){
    freopen("proba.txt","r",stdin);
   scanf("%d %d",&n,&k);
   for(int i=1;i<=n;i++){
      scanf("%d",&autori[i]);
   }
   for(int i=0;i<k;i++){
   scanf("%d %d",&prvi,&drugi);
   l=0;
   for(int j=prvi;j<=drugi;j++){
      s[l]=autori[j];
      l++;
   }
   std::sort(s,s+l);
   resenje[i]=drugi-prvi+1-isti(s,l);
}
   for(int i=0;i<k;i++){
   printf("%d\n",resenje[i]);
   }
}
